extends Node2D
class_name DragonListEntry


@export var color: AnimatedSprite2D
@export var hat: AnimatedSprite2D
@export var shirt: AnimatedSprite2D
@export var decor: AnimatedSprite2D

@export var color_outfits: DragonOutfit
@export var hat_outfits: DragonOutfit
@export var shirt_outfits: DragonOutfit
@export var decor_outfits: DragonOutfit


func play_animation(anim: String) -> void:
	if color.sprite_frames != null:
		color.set_frame(0)
		color.play(anim)
	if hat.sprite_frames != null:
		hat.set_frame(0)
		hat.play(anim)
	if shirt.sprite_frames != null:
		shirt.set_frame(0)
		shirt.play(anim)
	if decor.sprite_frames != null:
		decor.set_frame(0)
		decor.play(anim)


func face_direction(left: bool) -> void:
	color.flip_h = not left
	hat.flip_h = not left
	shirt.flip_h = not left
	decor.flip_h = not left


func dress(properties: DragonProperties) -> void:
	color.sprite_frames = color_outfits.get_texture(properties.color)
	hat.sprite_frames = hat_outfits.get_texture(properties.hat)
	shirt.sprite_frames = shirt_outfits.get_texture(properties.shirt)
	decor.sprite_frames = decor_outfits.get_texture(properties.decor)
